# Tinvest Robot Perevalov

Tinvest Robot Perevalov - это Python Библиотека, реализующая функциональность торгового робота на основе [Tinkoff Invest API для Python](https://github.com/Tinkoff/invest-python) с торговой стратегией, [**основанной на анализе тональности новостей**](https://ru.wikipedia.org/wiki/%D0%90%D0%BD%D0%B0%D0%BB%D0%B8%D0%B7_%D1%82%D0%BE%D0%BD%D0%B0%D0%BB%D1%8C%D0%BD%D0%BE%D1%81%D1%82%D0%B8_%D1%82%D0%B5%D0%BA%D1%81%D1%82%D0%B0).

## Описание торговой стратегии

**Торговая стратегия** основана на **анализе тональности новостей**. При получении новой новости производится анализ её тональности, в результате которого получаем один из трёх классов: `positive`, `negative`, или `neutral`.
После чего, **проверяется наличие упоминания той или иной компании в заголовке новости**.
Если компания упомянута, то в случае новости с классом `positive` посылается сигнал на **покупку** акций в заданном количестве.
Если новость с классом `negative`, то посылается сигнал на **продажу** акций в заданном количестве.

Ниже на рисунке представлена концептуальная схема стратегии на определённом примере.

![Схема стратегии](data/resources/strategy-big-picture.jpg)

Как видно, ключевым звеном является модуль анализа тональности, в качестве которого используется предобученная нейронная языковая модель (neural language model).

## Тестирование торговой стратегии (Backtesting)

Тестирование стратегии проводилось на наборе данных новостей ["Historical financial news archive"](https://www.kaggle.com/datasets/gennadiyr/us-equities-news-data), который содержит в себе новостные данные по 800 компаниям из США за 12 лет (2008-2020).

В ходе тестирования был выбран диапазон **с 2012 по 2020 годы** включительно по **100 наиболее упоминаемым компаниям** из набора данных. Поскольку некоторые компании оказались недоступны через сервис Тинькофф Инвестиции, в итоге в процедуру тестирования было включено **90 компаний**.

В рамках наблюдаемого года (например 2013) бралось соответствующее подмножество новостей **упорядоченных по дате** по возрастанию. После чего по каждой из компаний проверялось упоминание в той или иной новости и далее использовался алгоритм **стратегии** описанной выше со **следующими условиями**:

* Комиссия за операции не учитывалась;
* Покупка в шорт (в минус) недоступна;
* Покупка и продажа производится по одному лоту за раз;
* Финансовый результат считался по определённой бумаге за конкретный год;
* Данные по цене (свечи) брались из API Тинькофф Инвестиции;
* Если на конец года на балансе имелось ненулевой число акций, то финальный баланс на год рассчитывался по цене закрытия бумаг в последний торговый день года.

Ниже представленые некоторые графики по результатам тестирования.

![Доход по годам](data/resources/income-per-year.jpg)

На графике мы видим, что доходность была положительной почти на всех годах, за исключением 2018. Также, очевидно что доходность не зависит от количества операций по бумагам (это было так же подтверждено анализом коррелляции).

![Доход по тикерам](data/resources/income-per-ticker.jpg)

На графике не уместились все тикеры, однако в топ-3 самых доходных компаний входят: TSLA (64.72%), NFLX (28.62%), AAPL (18.68%) в среднем за год. Также, очевидно, что большинство бумаг оказались с положительной доходностью.

## Как запустить решение (How to run)

